#!/bin/sh

# test addfile

. tap.sh

plan 7

PF=test.db

rm -f $PF test.empty
touch test.empty

zpm init $PF
okexit create addfile test db

hash=$(zpm addfile $PF test.empty 2>> test.out)
okexit add empty file content
okstreq "$hash" 0e5751c026e543b2e8ab2eb06099daa1d1e5df47778f7787faab45cdf12fe3a8 hash contents
appid=$(sqlite3 test.db 'pragma application_id')
okstreq $appid 1515209794 application id set

userv=$(sqlite3 test.db 'pragma user_version')
okstreq $userv 1 db version set

mkdir test.dir
zpm-addfile $PF test.dir 2>>test.out
failsok fail to add directory
rmdir test.dir

zpm-addfile $PF /dev/null 2>>test.out
failsok fail to device file

finish

rm -f $PF test.empty
